# -*- coding: utf-8 -*-
#!/usr/bin/python
from PIL import Image
import sys
import random
from pandac.PandaModules import *
import direct.directbase.DirectStart
from direct.showbase.DirectObject import DirectObject
from camera import CamFree
CamFree()

class WorldGen(DirectObject):
    def __init__(self):

        self.point = 0
        self.hag = 0

        self.terrain = GeoMipTerrain("Terrain")
        self.terrain.setHeightfield(Filename('data/land01-map.png'))
        self.terrain.setBlockSize(32)
        self.terrain.setFactor(100)
        #self.terrain.setFocalPoint(base.camera)
        self.terrain.getRoot().reparentTo(render)
        self.terrain.getRoot().setPos(0, 0, -500)
        self.terrain.getRoot().setSz(150)
        self.terrain.generate()
        gnodes = self.terrain.getRoot().findAllMatches("+GeomNode")

        for gnode in gnodes:
            gnode.node().setIntoCollideMask(BitMask32.bit(1))

        # -
        self.relief = Image.open("data/land01-map.png") #  
        self.mask = Image.new("RGBA", (512,512), (0,0,0,0)) #    ,  4- .
        rgba = self.mask.split() #   
        self.red = rgba[0] #    
        self.green = rgba[1] #     
        self.blue = rgba[2] #    
        self.alfa = rgba[3] #    
        # - 

        collTrav = CollisionTraverser() # ,  
        collTrav.showCollisions(render) #     -   ,    

        self.player = NodePath("panda")
        self.player.reparentTo(render)
        fromObject = self.player.attachNewNode(CollisionNode('colNode'))
        fromObject.node().addSolid(CollisionRay(0, 0, 0, 0, 0, -1))
        fromObject.node().setFromCollideMask(BitMask32.bit(1))

        self.queue = CollisionHandlerQueue()
        collTrav.addCollider(fromObject, self.queue)

        base.cTrav = collTrav
        collTrav.traverse(render)

        taskMgr.add(self.genkart, '222') #  
        #taskMgr.add(self.scan, 'life+')
       
    def scan1(self, task):
        for x in range(512):
            for y in range(512):
                n = self.terrain.getNormal(x,y)
                n.normalize()
                dot = abs(Vec3(0,0,1).dot(n))
                if 0.999995 > dot: 
                    self.red.putpixel((x, y), 0)
                    self.green.putpixel((x, y), 0)
                    self.blue.putpixel((x, y), 0)
                    self.alfa.putpixel((x, y), 255)
                    None

        self.mask = Image.merge("RGBA", (self.red,self.green,self.blue,self.alfa)) #  
        self.mask.save("data/default_d.png") #  '''
        sys.exit()

    def scan(self, task):
        self.point += 1
        self.player.setPos(self.point, self.hag, 0)
        if (self.queue.getNumEntries() > 0): #        ()
            info1 = self.queue.getEntry(0) #     
            r = info1.getInto().getNormal()
            #Vec3(0,1,0).dot(r)
            print Vec3(0,1,0).dot(r)
        if 512 != self.point:
            return  task.cont #       .
        else:
            self.point = 0
            self.hag += 1
            print self.hag
            if 512 == self.hag:
                taskMgr.remove('life+')
            return  task.cont #       .

    def genkart(self, task):
        for y in range(512):
            for x in range(512):
                #     0  75
                if 0 < self.relief.getpixel((x, y))[0] < 75:
                    self.red.putpixel((x, y), 255 )
                #     75  120
                if 74 < self.relief.getpixel((x, y))[0] < 90:
                    self.green.putpixel((x, y), 255 )
                #     75  170
                if 89 < self.relief.getpixel((x, y))[0] < 255:
                    self.blue.putpixel((x, y), 255 )
                #if 79 < self.relief.getpixel((x, y))[0] < 255:
                    #self.alfa.putpixel((x, y), 255 )
        taskMgr.add(self.scan1, 'life++')

WorldGen()

run()