 # rendering Earthsculptor terrain with panda
# Author:weihuan, Email:kutawei@yahoo.cn, 2008/06/29
from pandac.PandaModules import *
import direct.directbase.DirectStart
from direct.showbase.DirectObject import DirectObject
from direct.gui.OnscreenText import OnscreenText
import sys

from camera import CamFree
CamFree()

class World(DirectObject):

    def __init__(self):


        self.terrain = GeoMipTerrain("Terrain")
        self.terrain.setHeightfield(Filename('data/land01-map.png'))
        self.terrain.setBlockSize(32)
        self.terrain.setFactor(100)
        #self.terrain.setFocalPoint(base.camera)
        self.terrain.getRoot().reparentTo(render)
        self.terrain.getRoot().setPos(0, 0, -500)
        self.terrain.getRoot().setSz(150)
        self.terrain.generate()

        #load textures
        tex0 = loader.loadTexture("data/default_d.png")
        tex0.setMinfilter(Texture.FTLinearMipmapLinear)
        tex1 = loader.loadTexture("data/grayRock.png")
        tex1.setMinfilter(Texture.FTLinearMipmapLinear)
        tex2 = loader.loadTexture("data/hardDirt.png")
        tex2.setMinfilter(Texture.FTLinearMipmapLinear)
        tex3 = loader.loadTexture("data/shortGrass.png")
        tex3.setMinfilter(Texture.FTLinearMipmapLinear)
        tex4 = loader.loadTexture("data/bigRockFace.png")
        tex4.setMinfilter(Texture.FTLinearMipmapLinear)
        tex5 = loader.loadTexture("data/default_c.png")
        tex5.setMinfilter(Texture.FTLinearMipmapLinear)
        tex6 = loader.loadTexture("data/default_l.png")
        tex6.setMinfilter(Texture.FTLinearMipmapLinear)
        #set mutiltextures
        self.terrain.getRoot().setTexture( TextureStage('tex0'),tex0 )
        self.terrain.getRoot().setTexture( TextureStage('tex1'),tex1 )
        self.terrain.getRoot().setTexture( TextureStage('tex2'),tex2 )
        self.terrain.getRoot().setTexture( TextureStage('tex3'),tex3 )
        self.terrain.getRoot().setTexture( TextureStage('tex4'),tex4 )
        self.terrain.getRoot().setTexture( TextureStage('tex5'),tex5 )
        self.terrain.getRoot().setTexture( TextureStage('tex6'),tex6 )
        #load shader
        self.terrain.getRoot().setShader(loader.loadShader('terraintexture.sha'))
             
        self.accept('escape', sys.exit)

if __name__ == '__main__':
    myworld = World()
    run( ) 
